(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";






var _constructor = require("../constructor");
var _utils = require("../utils");var clientSystem = client.registerSystem(0, 0);var playerID = undefined;var generatorIndex = 0;var tick = 0;var buildInstructionsQuery = [];
let generatorArray = [];
let coordinatePlayerLookingAt = undefined;



clientSystem.initialize = function () {


  clientSystem.registerEventData("NormaConstructor:ExecutionResponse", { playerID: undefined, buildInstructions: undefined });
  clientSystem.registerEventData("NormaConstructor:setServerSideOption", { playerID: undefined, option: { key: undefined, value: undefined } });
  clientSystem.registerEventData("NormaConstructor:queryBlockType", {
    playerID: undefined,
    position: undefined });


  clientSystem.listenForEvent("minecraft:hit_result_continuous", eventData => {coordinatePlayerLookingAt = eventData.data.position;});
  clientSystem.listenForEvent("minecraft:client_entered_world", eventData => {

    playerID = _utils.utils.misc.generatePlayerIDFromUniqueID(eventData.data.player.__unique_id__);

    //Logging:
    const scriptLoggerConfig = clientSystem.createEventData("minecraft:script_logger_config");
    scriptLoggerConfig.data.log_errors = true;
    scriptLoggerConfig.data.log_information = true;
    scriptLoggerConfig.data.log_warnings = true;
    clientSystem.broadcastEvent("minecraft:script_logger_config", scriptLoggerConfig);

    //Set default setServerSideOption:(Yes I hate it too)
    setServerSideOption("__requestAdditionalPosition", false);
    setServerSideOption("__requestAdditionalBlockType", false);
    setServerSideOption("__requestAdditionalDirection", false);

    //Wait until the mobile version officially supports scripting API.

    // let loadUIEventData = clientSystem.createEventData("minecraft:load_ui")
    // loadUIEventData.data.path = "HUD.html"
    // loadUIEventData.data.options = {
    //     absorbs_input: false,
    //     always_accepts_input: false,
    //     force_render_below: true,
    //     is_showing_menu: false,
    //     render_game_behind: true,
    //     render_only_when_topmost: false,
    //     should_steal_mouse: true
    // }
    // clientSystem.broadcastEvent("minecraft:load_ui", loadUIEventData)

    //Need to enable "Enable Content Log File" in "General"-"Profile"-"Content Log Settings"
    client.log("Logging started");


  });



  clientSystem.listenForEvent("NormaConstructor:displayChatToClient", eventData => {
    if (playerID == eventData.data.playerID)
    displayChat(eventData.data.message);
  });
  clientSystem.listenForEvent("NormaConstructor:command", eventData => {
    if (playerID == eventData.data.playerID) {
      switch (eventData.data.command) {
        case "get_data":{
            displayObject(eventData.data.additionalData);

            let serveData = { blockType: undefined, position: undefined, direction: undefined };

            let direction = eventData.data.additionalData.direction;
            if (eventData.data.additionalData.playerRequest["direction"]) serveData.direction = direction;

            if (eventData.data.additionalData.isGetAir) serveData.blockType = new _constructor.BlockType("minecraft:air", null);

            if (eventData.data.additionalData.playerRequest["position"] || eventData.data.additionalData.playerRequest["blockType"]) {
              let rawCoordinate = coordinatePlayerLookingAt;
              if (rawCoordinate == null) {
                displayChat("§c Unable to get the block position. Please retry.");
              } else
              {
                let coordinate = rawCoordinate;
                function isCoordinatePlaneFacing(num) {
                  return Math.floor(num) == num;
                }
                if (isCoordinatePlaneFacing(rawCoordinate.x)) coordinate.x -= -180 <= direction.y && direction.y < 0 ? 0 : 1;
                if (isCoordinatePlaneFacing(rawCoordinate.y)) coordinate.y -= -90 <= direction.x && direction.x < 0 ? 0 : 1;
                if (isCoordinatePlaneFacing(rawCoordinate.z)) coordinate.z -= -90 <= direction.y && direction.y < 90 ? 0 : 1;
                coordinate.x = Math.floor(coordinate.x);
                coordinate.y = Math.floor(coordinate.y);
                coordinate.z = Math.floor(coordinate.z);

                let position = new _constructor.Position(coordinate, eventData.data.additionalData.tickingArea);

                if (eventData.data.additionalData.playerRequest["position"]) serveData.position = position;
                if (eventData.data.additionalData.playerRequest["blockType"]) {
                  let queryBlockTypeEventData = clientSystem.createEventData("NormaConstructor:queryBlockType");
                  queryBlockTypeEventData.position = position;
                  queryBlockTypeEventData.playerID = playerID;
                  clientSystem.broadcastEvent("NormaConstructor:queryBlockType", queryBlockTypeEventData);
                }
              }
            }
            storeData(serveData.blockType, serveData.position, serveData.direction);
            break;
          }
        case "remove_last_position":{
            displayChat("Removing the last position...");
            generatorArray[generatorIndex].removePosition();
            break;
          }
        case "remove_last_blocktype":{
            displayChat("Removing the last blockType...");
            generatorArray[generatorIndex].removeBlockType();
            break;
          }
        case "remove_last_direction":{
            displayChat("Removing the last direction...");
            generatorArray[generatorIndex].removeDirection();
            break;
          }
        case "choose_next_generator":{
            displayChat("Choosing next generator...");
            generatorIndex = (generatorIndex + 1) % generatorArray.length;
            displayChat("Current generator:");
            displayObject(generatorArray[generatorIndex]);
            break;
          }
        case "show_saved_data":{
            displayChat("Current positionArray:");
            displayObject(generatorArray[generatorIndex].positionArray);
            displayChat("Current blockTypeArray:");
            displayObject(generatorArray[generatorIndex].blockTypeArray);
            displayChat("Current directionArray:");
            displayObject(generatorArray[generatorIndex].directionArray);
            displayChat("Current option:");
            displayObject(generatorArray[generatorIndex].option);
            break;
          }
        case "execute":{
            execute();
            break;
          }
        case "show_menu":{
            let loadUIEventData = clientSystem.createEventData("minecraft:load_ui");
            loadUIEventData.data.path = "menu/menu.html";
            clientSystem.broadcastEvent("minecraft:load_ui", loadUIEventData);
            break;
          }}

    }
  });
  clientSystem.listenForEvent("NormaConstructor:serveData", eventData => {
    displayChat("RECEIVE:");
    displayObject(eventData);
    if (playerID == eventData.data.playerID) {
      storeData(eventData.data.blockType, eventData.data.position, eventData.data.direction);

    }
  });

  clientSystem.listenForEvent("minecraft:ui_event", eventData => {
    if (eventData.data.slice(0, eventData.data.indexOf(":")) == "NormaConstructor") {
      let uiData = JSON.parse(eventData.data.slice(eventData.data.indexOf(":") + 1));

      switch (uiData.type) {
        //Must wait until the UI is loaded

        case "get":{
            let sendUIEventData = clientSystem.createEventData("minecraft:send_ui_event");
            sendUIEventData.data.eventIdentifier = "NormaConstructor:get";
            sendUIEventData.data.data = JSON.stringify(generatorArray[generatorIndex].option[uiData.data], null, '    ');
            clientSystem.broadcastEvent("minecraft:send_ui_event", sendUIEventData);
            break;
          }
        case "set":{
            generatorArray[generatorIndex].option[uiData.data.key] = uiData.data.value;
            break;
          }
        case "callUIHandler":{
            generatorArray[generatorIndex].UIHandler(uiData.data);
            break;
          }
        case "command":{
            switch (uiData.data) {
              case "reload":{
                  let sendUIEventData = clientSystem.createEventData("minecraft:send_ui_event");
                  sendUIEventData.data.eventIdentifier = "NormaConstructor:reload";
                  sendUIEventData.data.data = JSON.stringify({
                    description: generatorArray[generatorIndex].description,
                    option: generatorArray[generatorIndex].option },
                  null, '    ');
                  clientSystem.broadcastEvent("minecraft:send_ui_event", sendUIEventData);
                  break;
                }
              case "execute":{
                  execute();
                  break;
                }
              case "closeMenu":{
                  let closeMenuEventData = clientSystem.createEventData("minecraft:unload_ui");
                  closeMenuEventData.data.path = "menu/menu.html";
                  clientSystem.broadcastEvent("minecraft:unload_ui", closeMenuEventData);
                  break;
                }
              case "chooseNextGenerator":{
                  generatorIndex = (generatorIndex + 1) % generatorArray.length;
                  break;
                }
              case "chooseLastGenerator":{
                  generatorIndex = (generatorIndex - 1 + generatorArray.length) % generatorArray.length;
                }}

            break;
          }
        case "setServerSideOption":{
            setServerSideOption(uiData.data.key, uiData.data.value);
            break;
          }
        case "displayChat":{
            displayChat(uiData.data);
            break;
          }}

    }
  });
};

clientSystem.update = function () {

  if (++tick % 5 == 0 && buildInstructionsQuery.length > 0) {

    let executionResponseEventData = clientSystem.createEventData("NormaConstructor:ExecutionResponse");
    executionResponseEventData.data.playerID = playerID;
    executionResponseEventData.data.buildInstructions = buildInstructionsQuery.splice(0, 100);
    clientSystem.broadcastEvent("NormaConstructor:ExecutionResponse", executionResponseEventData);
  }
};

clientSystem.shutdown = function () {
  //TODO:Ask the server to delete the profile.(Maybe...not necessary.)
};

function storeData(blockType, position, direction) {
  if (blockType != undefined) generatorArray[generatorIndex].addBlockType(blockType);
  if (position != undefined) generatorArray[generatorIndex].addPosition(position);
  if (direction != undefined) generatorArray[generatorIndex].addDirection(direction);
  if (generatorArray[generatorIndex].option["__executeOnAllSatisfied"] && generatorArray[generatorIndex].validateParameter() == "success") execute();
}
function execute() {
  let validateResult = generatorArray[generatorIndex].validateParameter();
  if (validateResult != "success")
  displayChat("§c " + validateResult);else
  {
    displayChat("Execution started.");

    //The "buildInstructions" was named "blockArray" as it only consisted of blocks that are to be placed.
    let buildInstructions = generatorArray[generatorIndex].generate();
    buildInstructionsQuery = buildInstructionsQuery.concat(buildInstructions);
    //The following line is the original code which append the array to the query. Sadly, it will throw an error when there's too many blocks.
    //I...am not even sure if it is fixed.
    //Array.prototype.push.apply(buildInstructionsQuery, buildInstructions);

    generatorArray[generatorIndex].postGenerate();
  }
}
function setServerSideOption(key, value) {
  let setServerSideOptionEventData = clientSystem.createEventData("NormaConstructor:setServerSideOption");
  setServerSideOptionEventData.data.playerID = playerID;
  setServerSideOptionEventData.data.option.key = key;
  setServerSideOptionEventData.data.option.value = value;
  clientSystem.broadcastEvent("NormaConstructor:setServerSideOption", setServerSideOptionEventData);
}

function displayObject(object) {
  displayChat(JSON.stringify(object, null, '    '));
}
function displayChat(message) {
  let eventData = clientSystem.createEventData("minecraft:display_chat_event");
  eventData.data.message = message;
  clientSystem.broadcastEvent("minecraft:display_chat_event", eventData);

}

///////////////////////////////////////////////////////////////////////////////////////////////////////
//Generators://////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////

/*(function () {
    generatorArray.push(
        new Generator(
            new Description("Test.",
                new Usage(
                    [],
                    [],
                    [],
                    [
                        { viewtype: "text", text: "NZ IS JULAO." },
                        {
                            viewtype: "button",
                            text: "Yes, NZ is JULAO.",
                            key: "CCC",
                            data: [
                                { value: "red", text: "Choosing red" },
                                { value: "blue", text: "Choosing blue" },
                                { value: "yellow", text: "Choosing yellow" }
                            ]
                        },
                        {
                            viewtype: "edittext",
                            text: "Of course, NZ is JULAO.",
                            key: "BBB",
                            default: 999
                        },
                        {
                            viewtype: "checkbox",
                            text: "We all agree, NZ is JULAO.",
                            key: "AAA",
                            data: [
                                { value: true, text: "Yes" },
                                { value: false, text: "OK." },
                            ]
                        }
                    ]
                )
            ),

            [],
            [],
            [],
            {
                "AAA": true,
                "BBB": 123,
                "CCC": "red"
            },

            function (position) {
                client.log(JSON.stringify(position, null, '    '))
            },
            function (blockType) {
                console.log(JSON.stringify(blockType, null, '    '))
            },
            function (direction) {
                console.log(JSON.stringify(direction, null, '    '))
            },
            function (index) {
            },
            function (index) {
            },
            function (index) {

            },

            function () {
            },
            function () {
            },
            function () {
            }
        )
    )
}());*/

(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Create a solid rectangle with two points.",
  new _constructor.Usage(
  ["First point", "Second point"],
  ["BlockType"],
  [],
  [
  {
    viewtype: "button",
    text: "Toggle quick execution.(Execute on all parameters satisfied)",
    key: "__executeOnAllSatisfied",
    data: [
    { value: true, text: "On" },
    { value: false, text: "Off" }] }])),





  [undefined, undefined],
  [undefined],
  [],
  {
    "positionArrayLengthRequired": 2,
    "blockTypeArrayLengthRequired": 1,
    "__executeOnAllSatisfied": false,
    "generateByServer": true },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    if (this.option.generateByServer) {
      return [{
        "type": "fill", "data": {
          blockType: this.blockTypeArray[0],
          startCoordinate: this.positionArray[0].coordinate,
          endCoordinate: this.positionArray[1].coordinate } }];


    } else
    {
      let blockArray = [];

      displayChat("§b NZ is JULAO!");

      let positionArray = this.positionArray;
      let blockTypeArray = this.blockTypeArray;
      let minCoordinate = new _constructor.Coordinate(
      Math.min(positionArray[0].coordinate.x, positionArray[1].coordinate.x),
      Math.min(positionArray[0].coordinate.y, positionArray[1].coordinate.y),
      Math.min(positionArray[0].coordinate.z, positionArray[1].coordinate.z));

      let maxCoordinate = new _constructor.Coordinate(
      Math.max(positionArray[0].coordinate.x, positionArray[1].coordinate.x),
      Math.max(positionArray[0].coordinate.y, positionArray[1].coordinate.y),
      Math.max(positionArray[0].coordinate.z, positionArray[1].coordinate.z));


      displayChat("§b Yes, NZ is JULAO!");

      for (let x = minCoordinate.x; x <= maxCoordinate.x; x++) {
        for (let y = minCoordinate.y; y <= maxCoordinate.y; y++) {
          for (let z = minCoordinate.z; z <= maxCoordinate.z; z++) {

            blockArray.push(new _constructor.Block(
            new _constructor.Position(
            new _constructor.Coordinate(x, y, z),
            positionArray[0].tickingArea),

            blockTypeArray[0]));

          }
        }
      }

      return blockArray;
    }

  },
  function () {
    this.positionArray = [undefined, undefined];
    this.blockTypeArray = [undefined];
  }));


})();

(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Clone, ignoring direction.",
  new _constructor.Usage(
  [],
  [],
  [],
  [])),


  [undefined, undefined, undefined],
  [],
  [],
  {
    "positionArrayLengthRequired": 3,
    "blockTypeArrayLengthRequired": 0,
    "generateByServer": true },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    if (this.option.generateByServer)
    return [{
      "type": "clone",
      "data": {
        startCoordinate: this.positionArray[0].coordinate,
        endCoordinate: this.positionArray[1].coordinate,
        targetCoordinate: this.positionArray[2].coordinate } }];else


    return [];
  },
  function () {
    this.positionArray = [undefined, undefined, undefined];
    this.blockTypeArray = [];
  }));


})();

(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Create a line with given interval.",
  new _constructor.Usage(
  ["Start point"],
  ["BlockType"],
  ["Direction"],
  [
  {
    viewtype: "edittext",
    text: "Length:",
    key: "length" },

  {
    viewtype: "edittext",
    text: "Interval:",
    key: "interval" }])),




  [undefined],
  [undefined],
  [undefined],
  {
    "positionArrayLengthRequired": 1,
    "blockTypeArrayLengthRequired": 1,
    "directionArrayLengthRequired": 1,
    "length": 0,
    "interval": 0 },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (this.directionArray.indexOf(undefined) != -1)
    result += "Too few directions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    let blockArray = [];

    displayChat("§b NZ is JULAO!");

    let positionArray = this.positionArray;
    let blockTypeArray = this.blockTypeArray;
    let directionArray = this.directionArray;

    displayChat("§b Yes, NZ is JULAO!");


    let direction = function () {
      if (-45 <= directionArray[0].y && directionArray[0].y <= 45) return "+z";else
      if (-135 <= directionArray[0].y && directionArray[0].y <= -45) return "+x";else
      if (45 <= directionArray[0].y && directionArray[0].y <= 135) return "-x";else
      return "-z";
    }();

    switch (direction) {
      case "+z":{
          let x = positionArray[0].coordinate.x;
          let y = positionArray[0].coordinate.y;
          for (let z = positionArray[0].coordinate.z; z < this.option.length + positionArray[0].coordinate.z; z += this.option.interval + 1)
          blockArray.push(new _constructor.Block(
          new _constructor.Position(
          new _constructor.Coordinate(x, y, z),
          positionArray[0].tickingArea),

          blockTypeArray[0]));

          break;
        }
      case "-z":{
          let x = positionArray[0].coordinate.x;
          let y = positionArray[0].coordinate.y;
          for (let z = positionArray[0].coordinate.z; z > -this.option.length + positionArray[0].coordinate.z; z -= this.option.interval + 1)
          blockArray.push(new _constructor.Block(
          new _constructor.Position(
          new _constructor.Coordinate(x, y, z),
          positionArray[0].tickingArea),

          blockTypeArray[0]));

          break;
        }
      case "+x":{
          let z = positionArray[0].coordinate.z;
          let y = positionArray[0].coordinate.y;
          for (let x = positionArray[0].coordinate.x; x < this.option.length + positionArray[0].coordinate.x; x += this.option.interval + 1)
          blockArray.push(new _constructor.Block(
          new _constructor.Position(
          new _constructor.Coordinate(x, y, z),
          positionArray[0].tickingArea),

          blockTypeArray[0]));

          break;
        }
      case "-x":{
          let z = positionArray[0].coordinate.z;
          let y = positionArray[0].coordinate.y;
          for (let x = positionArray[0].coordinate.x; x > -this.option.length + positionArray[0].coordinate.z; x -= this.option.interval + 1)
          blockArray.push(new _constructor.Block(
          new _constructor.Position(
          new _constructor.Coordinate(x, y, z),
          positionArray[0].tickingArea),

          blockTypeArray[0]));

          break;
        }}


    return blockArray;
  },
  function () {
    this.positionArray = [undefined];
    this.blockTypeArray = [undefined];
    this.directionArray = [undefined];
  }));


})();

(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("造马路",
  new _constructor.Usage(
  [],
  [],
  [],
  [
  {
    viewtype: "edittext",
    text: "长度:",
    key: "length" },

  {
    viewtype: "button",
    text: "马路风格",
    key: "roadStyle",
    data: [
    { value: "NS", text: "北冥/南冥", dataForUIHandler: "preset" },
    { value: "DB", text: "东沙/冰岛", dataForUIHandler: "preset" },
    { value: "custom", text: "自定", dataForUIHandler: "custom" }] },


  {
    viewtype: "checkbox",
    text: "加护栏",
    key: "isBarred",
    data: [
    { value: true, text: "是" },
    { value: false, text: "否" }] },


  {
    viewtype: "edittext",
    text: "每一边车道数:",
    key: "numberOfLanesPerSide" },

  {
    viewtype: "edittext",
    text: "车道宽:",
    key: "widthOfLanes" },

  {
    viewtype: "edittext",
    text: "白线间隔:",
    key: "dashLineInterval" },

  {
    viewtype: "edittext",
    text: "白线长度:",
    key: "dashLineLength" }])),




  [undefined],
  [],
  [undefined],
  {
    "length": 10,
    "roadStyle": "NS",
    "isBarred": false,
    "numberOfLanesPerSide": 2,
    "widthOfLanes": 5,
    "dashLineInterval": 3,
    "dashLineLength": 4 },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (this.directionArray.indexOf(undefined) != -1)
    result += "Too few directions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    let blockArray = [];

    displayChat("§b NZ is JULAO!");

    let positionArray = this.positionArray;
    let blockTypeArray = this.blockTypeArray;
    let directionArray = this.directionArray;
    let option = this.option;

    displayChat("§b Yes, NZ is JULAO!");

    //{"blockIdentifier":"minecraft:stained_hardened_clay","blockState":{"color":"cyan"}}

    let materials;
    if (option["roadStyle"] == "NS") materials = {
      "surface": new _constructor.BlockType("minecraft:stained_hardened_clay", { "color": "cyan" }),
      "white_line": new _constructor.BlockType("minecraft:concrete", { "color": "white" }),
      "yellow_line": new _constructor.BlockType("minecraft:stained_hardened_clay", { "color": "yellow" }),
      "bar": new _constructor.BlockType("minecraft:cobblestone_wall", { "wall_block_type": "cobblestone" }) };else

    if (option["roadStyle"] == "DB") {
      materials = {
        "surface": new _constructor.BlockType("minecraft:wool", { "color": "black" }),
        "white_line": new _constructor.BlockType("minecraft:wool", { "color": "white" }),
        "yellow_line": new _constructor.BlockType("minecraft:wool", { "color": "yellow" }),
        "bar": new _constructor.BlockType("minecraft:cobblestone_wall", { "wall_block_type": "cobblestone" }) };

    } else
    if (option["roadStyle"] == "custom") {
      materials = {
        "surface": blockTypeArray[0],
        "white_line": blockTypeArray[1],
        "yellow_line": blockTypeArray[2],
        "bar": blockTypeArray[3] };

    }

    let playerFacingAxis = function () {
      if (-45 <= directionArray[0].y && directionArray[0].y <= 45) return "+z";else
      if (-135 <= directionArray[0].y && directionArray[0].y <= -45) return "+x";else
      if (45 <= directionArray[0].y && directionArray[0].y <= 135) return "-x";else
      return "-z";
    }();

    //This assumes the original facing axis is +x.
    let transform = function (facingAxis) {
      switch (facingAxis) {
        case "+x":{
            return _utils.utils.coordinateGeometry.transform(
            (x, y, z) => x,
            (x, y, z) => y,
            (x, y, z) => z);

            break;
          }
        case "-x":{
            return _utils.utils.coordinateGeometry.transform(
            (x, y, z) => 2 * positionArray[0].coordinate.x - x,
            (x, y, z) => y,
            (x, y, z) => 2 * positionArray[0].coordinate.z - z);

            break;
          }
        case "+z":{
            return _utils.utils.coordinateGeometry.transform(
            (x, y, z) => positionArray[0].coordinate.x - (z - positionArray[0].coordinate.z),
            (x, y, z) => y,
            (x, y, z) => positionArray[0].coordinate.z + (x - positionArray[0].coordinate.x));

            break;
          }
        case "-z":{
            return _utils.utils.coordinateGeometry.transform(
            (x, y, z) => positionArray[0].coordinate.x + (z - positionArray[0].coordinate.z),
            (x, y, z) => y,
            (x, y, z) => positionArray[0].coordinate.z - (x - positionArray[0].coordinate.x));

            break;
          }}

    }(playerFacingAxis);



    let palette = [];

    for (let i = 0; i < option["numberOfLanesPerSide"]; i++) {
      for (let j = 0; j < option["widthOfLanes"]; j++) palette.push("lane");
      if (i < option["numberOfLanesPerSide"] - 1) palette.push("dash_line");
    }
    palette.push("division_line");
    for (let i = 0; i < option["numberOfLanesPerSide"]; i++) {
      for (let j = 0; j < option["widthOfLanes"]; j++) palette.push("lane");
      if (i < option["numberOfLanesPerSide"] - 1) palette.push("dash_line");
    }
    if (option["isBarred"]) palette[0] = palette[palette.length - 1] = "edge";

    const offset = (palette.length - 1) / 2;
    for (let i = 0; i < palette.length; i++) {
      switch (palette[i]) {
        case "edge":{
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["surface"]));


            }
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y + 1, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y + 1, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["bar"]));


            }
            break;
          }
        case "lane":{
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["surface"]));


            }
            break;
          }
        case "dash_line":{
            for (let j = 0; j <= option["length"] - 1; j++) {
              let position = new _constructor.Position(transform(new _constructor.Coordinate(positionArray[0].coordinate.x + j, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset)), positionArray[0].tickingArea);
              if (j % (option["dashLineInterval"] + option["dashLineLength"]) < option["dashLineInterval"]) //Black first.
                blockArray.push(new _constructor.Block(position, materials["surface"]));else

              blockArray.push(new _constructor.Block(position, materials["white_line"]));
            }
            break;
          }
        case "division_line":{
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["yellow_line"]));


            }
            break;
          }}

    }

    return blockArray;
  },
  function () {
    this.positionArray = [undefined];
    if (this.option["roadStyle"] == "custom") this.blockTypeArray = [undefined, undefined, undefined, undefined];else
    this.blockTypeArray = [];
    this.blockTypeArray = [];
    this.directionArray = [undefined];
  },
  function (data) {
    if (data == "custom") {
      displayChat("Using custom materials.");
      displayChat("First block type for surface.");
      displayChat("Second for white line.");
      displayChat("Third for yellow line.");
      displayChat("Fourth for bar.");
      this.blockTypeArray = [undefined, undefined, undefined, undefined];
    } else
    {
      displayChat("Using preset materials. Custom materials are erased!");
      this.blockTypeArray = [];
    }
  }));


})();

(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Construct railway",
  new _constructor.Usage(
  [],
  [],
  [],
  [
  {
    viewtype: "edittext",
    text: "Length:",
    key: "length" },

  {
    viewtype: "checkbox",
    text: "加护栏",
    key: "isBarred",
    data: [
    { value: true, text: "是" },
    { value: false, text: "否" }] }])),





  [undefined],
  [],
  [undefined],
  {
    "length": 10,
    "isBarred": false },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (this.directionArray.indexOf(undefined) != -1)
    result += "Too few directions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    let blockArray = [];

    displayChat("§b NZ is JULAO!");

    let positionArray = this.positionArray;
    let blockTypeArray = this.blockTypeArray;
    let directionArray = this.directionArray;
    let option = this.option;

    displayChat("§b Yes, NZ is JULAO!");

    let directionMark = function () {
      if (-45 <= directionArray[0].y && directionArray[0].y <= 45) return "+z";else
      if (-135 <= directionArray[0].y && directionArray[0].y <= -45) return "+x";else
      if (45 <= directionArray[0].y && directionArray[0].y <= 135) return "-x";else
      return "-z";
    }();

    let materials = {
      "glass_pane": new _constructor.BlockType("minecraft:glass_pane", null),
      "iron_block": new _constructor.BlockType("minecraft:iron_block", null),
      "red_stone_torch": new _constructor.BlockType("minecraft:redstone_torch", { "torch_facing_direction": "top" }),
      "rail": _utils.utils.blockGeometry.setBlockDirection(new _constructor.BlockType("minecraft:golden_rail", { "rail_data_bit": false, "rail_direction": 0 }), directionMark == "+x" || directionMark == "-x" ? "x" : "z") };




    //This assumes the original facing axis is +x.
    let transform = function (facingAxis) {
      switch (facingAxis) {
        case "+x":{
            return _utils.utils.coordinateGeometry.transform(
            (x, y, z) => x,
            (x, y, z) => y,
            (x, y, z) => z);

            break;
          }
        case "-x":{
            return _utils.utils.coordinateGeometry.transform(
            (x, y, z) => 2 * positionArray[0].coordinate.x - x,
            (x, y, z) => y,
            (x, y, z) => 2 * positionArray[0].coordinate.z - z);

            break;
          }
        case "+z":{
            return _utils.utils.coordinateGeometry.transform(
            (x, y, z) => positionArray[0].coordinate.x - (z - positionArray[0].coordinate.z),
            (x, y, z) => y,
            (x, y, z) => positionArray[0].coordinate.z + (x - positionArray[0].coordinate.x));

            break;
          }
        case "-z":{
            return _utils.utils.coordinateGeometry.transform(
            (x, y, z) => positionArray[0].coordinate.x + (z - positionArray[0].coordinate.z),
            (x, y, z) => y,
            (x, y, z) => positionArray[0].coordinate.z - (x - positionArray[0].coordinate.x));

            break;
          }}

    }(directionMark);

    let palette = ["rail", "redstone", "rail"];

    if (option["isBarred"]) {
      palette.unshift("edge");
      palette.push("edge");
    }

    const offset = (palette.length - 1) / 2;
    for (let i = 0; i < palette.length; i++) {
      switch (palette[i]) {
        case "edge":{
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["iron_block"]));


            }
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y + 1, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y + 1, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["glass_pane"]));


            }
            break;
          }
        case "rail":{
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["iron_block"]));


            }
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y + 1, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y + 1, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["rail"]));


            }
            break;
          }
        case "redstone":{
            for (let coordinate of _utils.utils.coordinateGeometry.generateLineWithTwoPoints(
            positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset,
            positionArray[0].coordinate.x + option["length"] - 1, positionArray[0].coordinate.y, positionArray[0].coordinate.z + i - offset))
            {
              blockArray.push(
              new _constructor.Block(
              new _constructor.Position(
              transform(coordinate),
              positionArray[0].tickingArea),

              materials["iron_block"]));


            }
            for (let j = 0; j < option["length"] - 1; j++) {
              let position = new _constructor.Position(transform(new _constructor.Coordinate(positionArray[0].coordinate.x + j, positionArray[0].coordinate.y + 1, positionArray[0].coordinate.z + i - offset)), positionArray[0].tickingArea);
              if (j % 15 == 0) blockArray.push(new _constructor.Block(position, materials["red_stone_torch"]));
            }
            break;
          }}

    }

    return blockArray;
  },
  function () {
    this.positionArray = [undefined];
    this.blockTypeArray = [];
    this.directionArray = [undefined];
  }));


})();

(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Create a triangle.(Broken)",
  new _constructor.Usage(
  [],
  [],
  [],
  [])),


  [undefined, undefined, undefined],
  [undefined],
  [],
  {},

  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    let blockArray = [];

    displayChat("§b NZ is JULAO!");

    let positionArray = this.positionArray;
    let blockTypeArray = this.blockTypeArray;

    displayChat("§b Yes, NZ is JULAO!");

    let coordinateArray = _utils.utils.coordinateGeometry.generateFilledPlanarTriangle(
    positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z,
    positionArray[1].coordinate.x, positionArray[1].coordinate.y, positionArray[1].coordinate.z,
    positionArray[2].coordinate.x, positionArray[2].coordinate.y, positionArray[2].coordinate.z);

    for (const coordinate of coordinateArray) {
      blockArray.push(new _constructor.Block(
      new _constructor.Position(
      coordinate,
      positionArray[0].tickingArea),

      blockTypeArray[0]));

    }

    return blockArray;
  },
  function () {
    this.positionArray = [undefined, undefined, undefined];
    this.blockTypeArray = [undefined];
  }));


})();

(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Clear terrain",
  new _constructor.Usage(
  [],
  [],
  [],
  [])),


  [undefined, undefined],
  [],
  [],
  {
    "generateByServer": true },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    if (this.option.generateByServer) {
      displayChat("§b NZ is JULAO!");

      let x_min = Math.min(this.positionArray[0].coordinate.x, this.positionArray[1].coordinate.x);
      let z_min = Math.min(this.positionArray[0].coordinate.z, this.positionArray[1].coordinate.z);

      let x_max = Math.max(this.positionArray[0].coordinate.x, this.positionArray[1].coordinate.x);
      let z_max = Math.max(this.positionArray[0].coordinate.z, this.positionArray[1].coordinate.z);

      let y_start = Math.abs(this.positionArray[0].coordinate.y - 69) < Math.abs(this.positionArray[1].coordinate.y - 69) ? this.positionArray[0].coordinate.y : this.positionArray[1].coordinate.y;

      displayChat("§b Yes, NZ is JULAO!");

      return [{
        "type": "fill",
        "data": {
          "startCoordinate": new _constructor.Coordinate(x_min, y_start, z_min),
          "endCoordinate": new _constructor.Coordinate(x_max, 255, z_max),
          "blockType": {
            "blockIdentifier": "minecraft:air",
            "blockState": null } } }];



    } else
    {
      let blockArray = [];

      displayChat("§b NZ is JULAO!");

      let positionArray = this.positionArray;
      let blockTypeArray = this.blockTypeArray;

      let x_min = Math.min(positionArray[0].coordinate.x, positionArray[1].coordinate.x);
      let z_min = Math.min(positionArray[0].coordinate.z, positionArray[1].coordinate.z);

      let x_max = Math.max(positionArray[0].coordinate.x, positionArray[1].coordinate.x);
      let z_max = Math.max(positionArray[0].coordinate.z, positionArray[1].coordinate.z);

      let y_start = Math.abs(positionArray[0].coordinate.y - 69) < Math.abs(positionArray[1].coordinate.y - 69) ? positionArray[0].coordinate.y : positionArray[1].coordinate.y;

      displayChat("§b Yes, NZ is JULAO!");

      for (let x = x_min; x <= x_max; x++) {
        for (let y = y_start; y <= 256; y++) {
          for (let z = z_min; z <= z_max; z++) {

            blockArray.push(new _constructor.Block(
            new _constructor.Position(
            new _constructor.Coordinate(x, y, z),
            positionArray[0].tickingArea),

            {
              "blockIdentifier": "minecraft:air",
              "blockState": null }));


          }
        }
      }

      return blockArray;
    }
  },
  function () {
    this.positionArray = [undefined, undefined];
    this.blockTypeArray = [];
  }));


})();
(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Create polygon.",
  new _constructor.Usage(
  [],
  [],
  [],
  [
  {
    viewtype: "edittext",
    text: "Number of sides:",
    key: "numberOfSides" },

  {
    viewtype: "edittext",
    text: "Radius:",
    key: "r" }])),




  [undefined],
  [],
  [],
  {
    "numberOfSides": 6,
    "r": 10 },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    let blockArray = [];

    displayChat("§b NZ is JULAO!");

    let positionArray = this.positionArray;

    let coordinateArray = [];

    for (let theta = 0; theta <= 2 * Math.PI; theta += 2 * Math.PI / this.option.numberOfSides) {
      coordinateArray = coordinateArray.concat(_utils.utils.coordinateGeometry.withBresenhamAlgorithm.generateLineWithTwoPoints(
      positionArray[0].coordinate.x + this.option.r * Math.cos(theta), positionArray[0].coordinate.y, positionArray[0].coordinate.z + this.option.r * Math.sin(theta),
      positionArray[0].coordinate.x + this.option.r * Math.cos(theta + 2 * Math.PI / this.option.numberOfSides), positionArray[0].coordinate.y, positionArray[0].coordinate.z + this.option.r * Math.sin(theta + 2 * Math.PI / this.option.numberOfSides)));

    }

    displayObject(coordinateArray);

    for (let coordinate of coordinateArray)
    blockArray.push(new _constructor.Block(
    new _constructor.Position(
    coordinate,
    positionArray[0].tickingArea),

    new _constructor.BlockType("minecraft:stained_hardened_clay", { "color": "cyan" })));


    return blockArray;
  },
  function () {
    this.positionArray = [undefined];
    this.blockTypeArray = [];
  }));


})();
(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Create circle.(on xz plane)",
  new _constructor.Usage(
  [],
  [],
  [],
  [
  {
    viewtype: "edittext",
    text: "Radius:(Must be integer?)",
    key: "r" }])),




  [undefined],
  [undefined],
  [],
  {
    "r": 10 },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    let blockArray = [];



    displayChat("§b NZ is JULAO!");

    let positionArray = this.positionArray;
    let blockTypeArray = this.blockTypeArray;

    let coordinateArray = [];

    _utils.utils.coordinateGeometry.withBresenhamAlgorithm.generate2DCircle(positionArray[0].coordinate.x, positionArray[0].coordinate.z, this.option.r).
    forEach(coordinate => {
      coordinateArray.push(new _constructor.Coordinate(coordinate.x, positionArray[0].coordinate.y, coordinate.y));
    });


    displayObject(coordinateArray);

    for (let coordinate of coordinateArray)
    blockArray.push(new _constructor.Block(
    new _constructor.Position(
    coordinate,
    positionArray[0].tickingArea),

    blockTypeArray[0]));


    return blockArray;
  },
  function () {
    this.positionArray = [undefined];
    this.blockTypeArray = [undefined];
  }));


})();
(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Create sphere.",
  new _constructor.Usage(
  [],
  [],
  [],
  [
  {
    viewtype: "edittext",
    text: "Radius:",
    key: "r" },

  {
    viewtype: "button",
    text: "Hollow",
    key: "isHollow",
    data: [
    { value: true, text: "Yes" },
    { value: false, text: "No" }] }])),





  [undefined],
  [undefined],
  [],
  {
    "r": 10,
    "isHollow": false },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (result == "") result = "success";

    return result;
  },
  function () {
    let blockArray = [];



    displayChat("§b NZ is JULAO!");

    let positionArray = this.positionArray;
    let blockTypeArray = this.blockTypeArray;

    let coordinateArray = this.option.isHollow ?
    _utils.utils.coordinateGeometry.generateHollowSphere(positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z, this.option.r) :
    _utils.utils.coordinateGeometry.generateSphere(positionArray[0].coordinate.x, positionArray[0].coordinate.y, positionArray[0].coordinate.z, this.option.r);




    displayObject(coordinateArray);

    for (let coordinate of coordinateArray)
    blockArray.push(new _constructor.Block(
    new _constructor.Position(
    coordinate,
    positionArray[0].tickingArea),

    blockTypeArray[0]));


    return blockArray;
  },
  function () {
    this.positionArray = [undefined];
    this.blockTypeArray = [undefined];
  }));


})();
(function () {
  generatorArray.push(
  new _constructor.Generator(
  new _constructor.Description("Generate The Flag of Norma Federal Republic",
  new _constructor.Usage(
  [],
  [],
  [],
  [
  {
    viewtype: "edittext",
    text: "Height:(Must be even)",
    key: "height" }])),




  [undefined],
  [],
  [],
  {
    "height": 10 },


  function (position) {
    displayObject(position);
    let indexOfVacancy = this.positionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many positions!New one is ignored");else
    this.positionArray[indexOfVacancy] = position;
  },
  function (blockType) {
    displayObject(blockType);
    let indexOfVacancy = this.blockTypeArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many blockTypes!New one is ignored");else
    this.blockTypeArray[indexOfVacancy] = blockType;
  },
  function (direction) {
    displayObject(direction);
    let indexOfVacancy = this.directionArray.indexOf(undefined);
    if (indexOfVacancy == -1) displayChat("Too many directions!New one is ignored");else
    this.directionArray[indexOfVacancy] = direction;
  },
  function (index) {
    if (index === undefined)
    for (index = this.positionArray.length - 1; index >= 0 && this.positionArray[index] == undefined; index--);
    if (index >= 0) this.positionArray[index] = undefined;
    displayObject(this.positionArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.blockTypeArray.length - 1; index >= 0 && this.blockTypeArray[index] == undefined; index--);
    if (index >= 0) this.blockTypeArray[index] = undefined;
    displayObject(this.blockTypeArray);
  },
  function (index) {
    if (index === undefined)
    for (index = this.directionArray.length - 1; index >= 0 && this.directionArray[index] == undefined; index--);
    if (index >= 0) this.directionArray[index] = undefined;
    displayObject(this.directionArray);
  },

  function () {
    let result = new String();
    if (this.blockTypeArray.indexOf(undefined) != -1)
    result += "Too few blockTypes!Refusing to execute.\n";
    if (this.positionArray.indexOf(undefined) != -1)
    result += "Too few positions!Refusing to execute.";
    if (this.option.height % 2 != 0) result += "The height is odd!";
    if (result == "") result = "success";

    return result;
  },
  function () {
    let blockArray = [];
    let positionArray = this.positionArray;
    let option = this.option;

    for (let x = positionArray[0].coordinate.x; x < positionArray[0].coordinate.x + option.height; x++)
    for (let y = positionArray[0].coordinate.y; y > positionArray[0].coordinate.y - option.height; y--) {
      let z = x - positionArray[0].coordinate.x + positionArray[0].coordinate.z;
      let blockType = function () {
        if (x - positionArray[0].coordinate.x <= positionArray[0].coordinate.y - y && positionArray[0].coordinate.y - y < option.height - (x - positionArray[0].coordinate.x)) return new _constructor.BlockType("minecraft:wool", { "color": "blue" });else
        if (positionArray[0].coordinate.y - y < option.height / 2) return new _constructor.BlockType("minecraft:wool", { "color": "yellow" });else
        return new _constructor.BlockType("minecraft:wool", { "color": "red" });
      }();
      blockArray.push(new _constructor.Block(new _constructor.Position(new _constructor.Coordinate(x, y, z), positionArray[0].tickingArea), blockType));
    }


    return blockArray;
  },
  function () {
    this.positionArray = [undefined];
    this.blockTypeArray = [];
  }));


})();

},{"../constructor":2,"../utils":3}],2:[function(require,module,exports){
"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.Generator = exports.Description = exports.Usage = exports.Direction = exports.Block = exports.BlockType = exports.Position = exports.Coordinate = void 0; //TODO:Wrap up the constructor && find better solution.
class Coordinate {
  constructor(x, y, z) {
    this.x = x;
    this.y = y;
    this.z = z;
  }}exports.Coordinate = Coordinate;

class Position {
  constructor(coordinate, tickingArea) {
    this.coordinate = coordinate;
    this.tickingArea = tickingArea;
  }}exports.Position = Position;

class BlockType {
  constructor(blockIdentifier, blockState) {
    this.blockIdentifier = blockIdentifier;
    this.blockState = blockState;
  }}exports.BlockType = BlockType;

class Direction {
  constructor(x, y) {
    this.x = x;
    this.y = y;
  }}exports.Direction = Direction;

class Block {
  constructor(position, blockType) {
    this.position = position;
    this.blockType = blockType;
  }}exports.Block = Block;



class Usage {
  constructor(positionUsage, blockTypeUsage, directionUsage, optionUsage) {
    this.positionUsage = positionUsage;
    this.blockTypeUsage = blockTypeUsage;
    this.directionUsage = directionUsage;
    this.optionUsage = optionUsage;
  }}exports.Usage = Usage;

class Description {
  constructor(name, usage) {
    this.name = name;
    this.usage = usage;
  }}

//TODO:Refactor generator
exports.Description = Description;class Generator {
  constructor(description,
  positionArray, blockTypeArray, directionArray, option,
  addPosition, addBlockType, addDirection,
  removePosition, removeBlockType, removeDirection,
  validateParameter, generate, postGenerate, UIHandler) {
    this.description = description;

    this.positionArray = positionArray;
    this.blockTypeArray = blockTypeArray;
    this.directionArray = directionArray;
    this.option = option;

    this.addPosition = addPosition;
    this.addBlockType = addBlockType;
    this.addDirection = addDirection;
    this.removePosition = removePosition;
    this.removeBlockType = removeBlockType;
    this.removeDirection = removeDirection;

    this.validateParameter = validateParameter;
    this.generate = generate;
    this.postGenerate = postGenerate;
    this.UIHandler = UIHandler;
  }}exports.Generator = Generator;


class BuildInstruction {
  constructor(type, data) {
    this.type = type;
    this.data = data;
  }}

},{}],3:[function(require,module,exports){
"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.utils = void 0;
var _constructor = require("./constructor"); // eslint-disable-next-line no-unused-vars
const blockDirectionTable = {
  "huge_mushroom_bits": {
    "default": {
      "none": 0,
      "-x+y-z": 1,
      "+y-z": 2,
      "+x+y-z": 3,
      "-x+y": 4,
      "+y": 5,
      "+x+y": 6,
      "-x+y+z": 7,
      "+y+z": 8,
      "+x+y+z": 9,
      "+y-y": 10,
      "null": 11,
      "nil": 12,
      "NaN": 13,
      "all": 14,
      "stem": 15 } },


  "pillar_axis": {
    "default": {
      "+x": "x",
      "-x": "x",
      "+y": "y",
      "-y": "y",
      "+z": "z",
      "-z": "z" } },


  "axis": {
    "default": {
      "+x": "x",
      "-x": "x",
      "+z": "z",
      "-z": "z" } },


  "facing_direction": {
    "default": {
      "+x": 5,
      "-x": 4,
      "+y": 1,
      "-y": 0,
      "+z": 3,
      "-z": 2 } },


  "direction": {
    "minecraft:bed": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:wooden_door": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:iron_door": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:lit_pumpkin": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:trapdoor": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:fence_gate": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:end_portal_frame": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:cocoa": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:tripwire_hook": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:anvil": {
      "+x": 2,
      "-x": 0,
      "+z": 3,
      "-z": 1 },

    "minecraft:unpowered_repeater": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:powered_repeater": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:unpowered_comparator": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:powered_comparator": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:iron_trapdoor": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:spruce_fence_gate": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:birch_fence_gate": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:jungle_fence_gate": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:dark_oak_fence_gate": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:acacia_fence_gate": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:spruce_door": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:birch_door": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:jungle_door": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:acacia_door": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:dark_oak_door": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:acacia_trapdoor": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:birch_trapdoor": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:dark_oak_trapdoor": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:jungle_trapdoor": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:spruce_trapdoor": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 },

    "minecraft:carved_pumpkin": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:pumpkin": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:lectern": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:grindstone": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:loom": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:bell": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "minecraft:campfire": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 },

    "default": {
      "+x": 3,
      "-x": 1,
      "+z": 0,
      "-z": 2 } },


  "ground_sign_direction": {
    "default": {
      "0": 0,
      "22.5": 1,
      "45": 2,
      "67.5": 3,
      "90": 4,
      "112.5": 5,
      "135": 6,
      "157.5": 7,
      "180": 8,
      "-157.5": 9,
      "-135": 10,
      "-112.5": 11,
      "-90": 12,
      "-67.5": 13,
      "-45": 14,
      "-22.5": 15 } },


  "rail_direction": {
    "default": {
      "x": 0,
      "z": 1,
      "+x": 2,
      "-x": 3,
      "+z": 5,
      "-z": 4 } },


  "torch_facing_direction": {
    "default": {
      "-x": "west",
      "+x": "east",
      "-z": "north",
      "+z": "south",
      "y": "top" } },


  "weirdo_direction": {
    "default": {
      "+x": 0,
      "-x": 1,
      "+z": 2,
      "-z": 3 } },


  "lever_direction": {
    "default": {
      "x-y": "down_east_west",
      "+x": "east",
      "-x": "west",
      "+z": "south",
      "-z": "north",
      "z+y": "up_north_south",
      "x+y": "up_east_west",
      "z-y": "down_north_south" } },


  "portal_axis": {
    "default": {
      "+x": "x",
      "-x": "x",
      "+z": "z",
      "-z": "z" } },


  "vine_direction_bits": {
    "default": {
      "NZ IS JULAO": 0,
      "+z": 1,
      "-x": 2,
      "-x+z": 3,
      "-z": 4,
      "+z-z": 5,
      "-x-z": 6,
      "-x+z-z": 7,
      "+x": 8,
      "+x+z": 9,
      "+x-x": 10,
      "+x-x+z": 11,
      "+x-z": 12,
      "+x+z-z": 13,
      "+x-x-z": 14,
      "+x-x+z-z": 15 } } };



let translator = {
  directionMarkToDirection: function (directionMark) {
    switch (directionMark) {
      case "+x":return new _constructor.Direction(0, -90);
      case "-x":return new _constructor.Direction(0, 90);
      case "+y":return new _constructor.Direction(-90, 0);
      case "-y":return new _constructor.Direction(90, 0);
      case "+z":return new _constructor.Direction(0, 0);
      case "-z":return new _constructor.Direction(0, 180);

      case "x":return new _constructor.Direction(0, -90);
      case "y":return new _constructor.Direction(90, 0);
      case "z":return new _constructor.Direction(0, 0);
      default:{
          return "Ahhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh";
        }}

  } };

let utils = {
  misc: {
    generatePlayerIDFromUniqueID: function (uniqueID) {
      let low = uniqueID["64bit_low"];
      let high = uniqueID["64bit_high"];
      //hash function:

      return (low + high) * (low + high + 1) / 2 + high;
    } },

  coordinateGeometry: {
    transform: function (f, g, h) {
      return coordinate => {
        return new _constructor.Coordinate(
        f(coordinate.x, coordinate.y, coordinate.z),
        g(coordinate.x, coordinate.y, coordinate.z),
        h(coordinate.x, coordinate.y, coordinate.z));

      };
    },

    generateLine: function (x, y, z, t_span, constraint, t_step) {
      //TODO: t_step<0?t_span[0]>t_span[1]?
      let coordinateArray = [];

      function isRedundant(coordinateArray, newCoordinate) {
        if (coordinateArray.length == 0) return false;
        return (
          coordinateArray[coordinateArray.length - 1].x == newCoordinate.x &&
          coordinateArray[coordinateArray.length - 1].y == newCoordinate.y &&
          coordinateArray[coordinateArray.length - 1].z == newCoordinate.z);

      }

      if (t_step == undefined) t_step = 0.0001;
      for (let t = t_span[0]; t <= t_span[1]; t += t_step) {
        let newCoordinate = new _constructor.Coordinate(Math.round(x(t)), Math.round(y(t)), Math.round(z(t)));
        if (!isRedundant(coordinateArray, newCoordinate) && constraint(newCoordinate.x, newCoordinate.y, newCoordinate.z, t)) {

          coordinateArray.push(newCoordinate);
        }
      }
      return coordinateArray;
    },
    generateLineWithTwoPoints: function (x_start, y_start, z_start, x_end, y_end, z_end) {
      let t_span = [0, 1];
      let x_coefficient = (x_end - x_start) / (t_span[1] - t_span[0]);
      let y_coefficient = (y_end - y_start) / (t_span[1] - t_span[0]);
      let z_coefficient = (z_end - z_start) / (t_span[1] - t_span[0]);
      return this.generateLine(
      t => {return (t - t_span[0]) * x_coefficient + x_start;},
      t => {return (t - t_span[0]) * y_coefficient + y_start;},
      t => {return (t - t_span[0]) * z_coefficient + z_start;},
      t_span, (x, y, z, t) => {return true;}, Math.min(1 / x_coefficient, 1 / y_coefficient, 1 / z_coefficient));
    },
    generateTriangle: function (x1, y1, z1, x2, y2, z2, x3, y3, z3) {
      let coordinateArray = [];
      coordinateArray = coordinateArray.concat(this.generateLineWithTwoPoints(x1, y1, z1, x2, y2, z2));
      coordinateArray = coordinateArray.concat(this.generateLineWithTwoPoints(x2, y2, z2, x3, y3, z3));
      coordinateArray = coordinateArray.concat(this.generateLineWithTwoPoints(x3, y3, z3, x1, y1, z1));

      return coordinateArray;
    },
    generateFilledPlanarTriangle: function (x1, y1, z1, x2, y2, z2, x3, y3, z3) {
      const A = (y2 - y1) * (z3 - z1) - (y3 - y1) * (z2 - z1);
      const B = -((x2 - x1) * (z3 - z1) - (x3 - x1) * (z2 - z1));
      const C = (x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1);
      const G = new _constructor.Coordinate((x1 + x2 + x3) / 3, (y1 + y2 + y3) / 3, (z1 + z2 + z3) / 3);
      let x_span = [Math.min(x1, x2, x3), Math.max(x1, x2, x3)];
      let y_span = [Math.min(y1, y2, y3), Math.max(y1, y2, y3)];
      let z_span = [Math.min(z1, z2, z3), Math.max(z1, z2, z3)];

      function signedDistance(x_start, y_start, x_end, y_end) {
        return (x, y) => {return (y_end - y_start) * x - (x_end - x_start) * y + x_end * y_start - x_start * y_end;};
      }

      return this.generateWithConstraint(x_span, y_span, z_span, (x, y, z) => {
        return Math.abs(A * (x - x1) + B * (y - y1) + C * (z - z1)) < Math.sqrt(A * A + B * B + C * C) / 2 &&


        signedDistance(x1, y1, x2, y2)(x, y) * signedDistance(x1, y1, x2, y2)(G.x, G.y) >= 0 &&
        signedDistance(x1, y1, x3, y3)(x, y) * signedDistance(x1, y1, x3, y3)(G.x, G.y) >= 0 &&
        signedDistance(x2, y2, x3, y3)(x, y) * signedDistance(x2, y2, x3, y3)(G.x, G.y) >= 0 &&

        signedDistance(x1, z1, x2, z2)(x, z) * signedDistance(x1, z1, x2, z2)(G.x, G.z) >= 0 &&
        signedDistance(x1, z1, x3, z3)(x, z) * signedDistance(x1, z1, x3, z3)(G.x, G.z) >= 0 &&
        signedDistance(x2, z2, x3, z3)(x, z) * signedDistance(x2, z2, x3, z3)(G.x, G.z) >= 0 &&

        signedDistance(y1, z1, y2, z2)(y, z) * signedDistance(y1, z1, y2, z2)(G.y, G.z) >= 0 &&
        signedDistance(y1, z1, y3, z3)(y, z) * signedDistance(y1, z1, y3, z3)(G.y, G.z) >= 0 &&
        signedDistance(y2, z2, y3, z3)(y, z) * signedDistance(y2, z2, y3, z3)(G.y, G.z) >= 0;

      });
    },
    generateSphere: function (x, y, z, r) {
      return this.generateWithConstraint([x - r, x + r], [y - r, y + r], [z - r, z + r], (_x, _y, _z) => {return (_x - x) * (_x - x) + (_y - y) * (_y - y) + (_z - z) * (_z - z) < r * r;});
    },
    generateHollowSphere: function (x, y, z, r) {
      return this.generateWithConstraint([x - r, x + r], [y - r, y + r], [z - r, z + r], (_x, _y, _z) => {return (_x - x) * (_x - x) + (_y - y) * (_y - y) + (_z - z) * (_z - z) >= (r - 1) * (r - 1) && (_x - x) * (_x - x) + (_y - y) * (_y - y) + (_z - z) * (_z - z) < r * r;});
    },
    generateWithConstraint: function (x_span, y_span, z_span, constraint) {
      let coordinateArray = [];



      const x_step = 1 / 3;
      const y_step = 1 / 3;
      const z_step = 1 / 3;

      if (x_span[0] >= x_span[1]) {
        let temp = x_span[1];
        x_span[1] = x_span[0];
        x_span[0] = temp;
      }
      if (y_span[0] >= y_span[1]) {
        let temp = y_span[1];
        y_span[1] = y_span[0];
        y_span[0] = temp;
      }
      if (z_span[0] >= z_span[1]) {
        let temp = z_span[1];
        z_span[1] = z_span[0];
        z_span[0] = temp;
      }

      function verifier(x, y, z) {
        for (let _x = Math.max(x - x_step, x_span[0]); _x <= Math.min(x + x_step, x_span[1]); _x += x_step)
        for (let _z = Math.max(z - z_step, z_span[0]); _z <= Math.min(z + z_step, z_span[1]); _z += z_step)
        for (let _y = Math.max(y - y_step, y_span[0]); _y <= Math.min(y + y_step, y_span[1]); _y += y_step)
        if (constraint(_x, _y, _z)) return true;
        return false;
      }

      for (let x = x_span[0]; x <= x_span[1]; x += 1)
      for (let z = z_span[0]; z <= z_span[1]; z += 1)
      for (let y = y_span[0]; y <= y_span[1]; y += 1)
      if (verifier(x, y, z))
      coordinateArray.push(new _constructor.Coordinate(x, y, z));
      // function isRedundant(coordinateArray, newCoordinate) {
      // 	if (coordinateArray.length == 0) return false;
      // 	return (
      // 		coordinateArray[coordinateArray.length - 1].x == newCoordinate.x &&
      // 		coordinateArray[coordinateArray.length - 1].y == newCoordinate.y &&
      // 		coordinateArray[coordinateArray.length - 1].z == newCoordinate.z
      // 	)
      // }
      // for (let x = x_span[0]; x <= x_span[1]; x += x_step)
      // 	for (let z = z_span[0]; z <= z_span[1]; z += z_step)
      // 		for (let y = y_span[0]; y <= y_span[1]; y += y_step) 
      // 			if (constraint(x, y, z)) {
      // 				let newCoordinate = new Coordinate(Math.round(x), Math.round(y), Math.round(z))
      // 				if (!isRedundant(coordinateArray, newCoordinate))
      // 					coordinateArray.push(newCoordinate)
      // 			}



      return coordinateArray;

    },
    withBresenhamAlgorithm: {
      //Shamelessly adopted from http://members.chello.at/~easyfilter/bresenham.html (
      generateLineWithTwoPoints: function (x0, y0, z0, x1, y1, z1) {
        x0 = Math.round(x0);
        y0 = Math.round(y0);
        z0 = Math.round(z0);
        x1 = Math.round(x1);
        y1 = Math.round(y1);
        z1 = Math.round(z1);
        let coordinateArray = [];
        let dx = Math.abs(x1 - x0),sx = x0 < x1 ? 1 : -1;
        let dy = Math.abs(y1 - y0),sy = y0 < y1 ? 1 : -1;
        let dz = Math.abs(z1 - z0),sz = z0 < z1 ? 1 : -1;
        let dm = Math.max(dx, dy, dz),i = dm;
        x1 = y1 = z1 = Math.floor(dm / 2);

        for (;;) {
          coordinateArray.push(new _constructor.Coordinate(x0, y0, z0));
          if (i-- == 0) break;
          x1 -= dx;if (x1 < 0) {x1 += dm;x0 += sx;}
          y1 -= dy;if (y1 < 0) {y1 += dm;y0 += sy;}
          z1 -= dz;if (z1 < 0) {z1 += dm;z0 += sz;}
        }
        return coordinateArray;
      },
      generate2DEllipse: function (xm, ym, a, b) {
        let coordinateArray = [];
        function setPixel(x, y) {
          coordinateArray.push(new _constructor.Coordinate(x, y, 0));
        }
        var x = -a,y = 0; /* II. quadrant from bottom left to top right */
        var e2,dx = (1 + 2 * x) * b * b; /* error increment  */
        var dy = x * x,err = dx + dy; /* error of 1.step */

        do {
          setPixel(xm - x, ym + y); /*   I. Quadrant */
          setPixel(xm + x, ym + y); /*  II. Quadrant */
          setPixel(xm + x, ym - y); /* III. Quadrant */
          setPixel(xm - x, ym - y); /*  IV. Quadrant */
          e2 = 2 * err;
          if (e2 >= dx) {x++;err += dx += 2 * b * b;} /* x step */
          if (e2 <= dy) {y++;err += dy += 2 * a * a;} /* y step */
        } while (x <= 0);

        while (y++ < b) {/* too early stop for flat ellipses with a=1, */
          setPixel(xm, ym + y); /* -> finish tip of ellipse */
          setPixel(xm, ym - y);
        }
        return coordinateArray;
      },

      generate2DCircle: function (xm, ym, r) {
        let coordinateArray = [];
        function setPixel(x, y) {
          coordinateArray.push(new _constructor.Coordinate(x, y, 0));
        }
        var x = -r,y = 0,err = 2 - 2 * r; /* bottom left to top right */
        do {
          setPixel(xm - x, ym + y); /*   I. Quadrant +x +y */
          setPixel(xm - y, ym - x); /*  II. Quadrant -x +y */
          setPixel(xm + x, ym - y); /* III. Quadrant -x -y */
          setPixel(xm + y, ym + x); /*  IV. Quadrant +x -y */
          r = err;
          if (r <= y) err += ++y * 2 + 1; /* y step */
          if (r > x || err > y) err += ++x * 2 + 1; /* x step */
        } while (x < 0);
        return coordinateArray;
      },

      //Unsatisfactory. Will cause holes.
      generateFilledPlanarTriangle: function (x1, y1, z1, x2, y2, z2, x3, y3, z3) {
        let coordinateSet = new Set();
        let generateLine = this.generateLine;
        generateLine(x2, y2, z2, x3, y3, z3).forEach(({ x, y, z }) => {generateLine(x1, y1, z1, x, y, z).forEach(coordinate => {coordinateSet.add(coordinate);});});
        return coordinateSet.values();
      },
      generateEllipseRect: function (x0, y0, x1, y1) {/* rectangular parameter enclosing the ellipse */
        var a = Math.abs(x1 - x0),b = Math.abs(y1 - y0),b1 = b & 1; /* diameter */
        var dx = 4 * (1.0 - a) * b * b,dy = 4 * (b1 + 1) * a * a; /* error increment */
        var err = dx + dy + b1 * a * a,e2; /* error of 1.step */

        if (x0 > x1) {x0 = x1;x1 += a;} /* if called with swapped points */
        if (y0 > y1) y0 = y1; /* .. exchange them */
        y0 += b + 1 >> 1;y1 = y0 - b1; /* starting pixel */
        a = 8 * a * a;b1 = 8 * b * b;

        do {
          setPixel(x1, y0); /*   I. Quadrant */
          setPixel(x0, y0); /*  II. Quadrant */
          setPixel(x0, y1); /* III. Quadrant */
          setPixel(x1, y1); /*  IV. Quadrant */
          e2 = 2 * err;
          if (e2 <= dy) {y0++;y1--;err += dy += a;} /* y step */
          if (e2 >= dx || 2 * err > dy) {x0++;x1--;err += dx += b1;} /* x */
        } while (x0 <= x1);

        while (y0 - y1 <= b) {/* too early stop of flat ellipses a=1 */
          setPixel(x0 - 1, y0); /* -> finish tip of ellipse */
          setPixel(x1 + 1, y0++);
          setPixel(x0 - 1, y1);
          setPixel(x1 + 1, y1--);
        }
      } } },




  blockGeometry: {
    getBlockDirection: function (blockType) {
      let directionRelatedBlockStateKey = function () {
        //The following function decides which specific key controls how the block rotates, if it exists.
        //It is based on the fact that, only one blockState will decide how.
        //Hope it won't change.
        for (let blockStateKey in blockType.blockState)
        if (blockDirectionTable[blockStateKey] != undefined) return blockStateKey;
        return "";
      }();
      let directionMap = function () {
        if (blockDirectionTable[directionRelatedBlockStateKey][blockType.blockIdentifier] == undefined)
        return blockDirectionTable[directionRelatedBlockStateKey]["default"];else

        return blockDirectionTable[directionRelatedBlockStateKey][blockType.blockIdentifier];
      }();
      let directionMark = function () {
        for (let mark in directionMap)
        if (directionMap[mark] == blockType.blockState[directionRelatedBlockStateKey]) return mark;
        return "error";
      }();
      return translator.directionMarkToDirection(directionMark);
    },
    //The degree is absolute degree.
    setBlockDirection: function (blockType, directionMark) {
      //Ignoring special block that doesn't use "+x" etc for now.
      let directionRelatedBlockStateKey = function () {
        //The following function decides which specific key controls how the block rotates, if it exists.
        //It is based on the fact that, only one blockState will decide how.
        //Hope it won't change.
        for (let blockStateKey in blockType.blockState)
        if (blockDirectionTable[blockStateKey] != undefined) return blockStateKey;
        return "";
      }();
      let directionMap = function () {
        if (blockDirectionTable[directionRelatedBlockStateKey][blockType.blockIdentifier] == undefined)
        return blockDirectionTable[directionRelatedBlockStateKey]["default"];else

        return blockDirectionTable[directionRelatedBlockStateKey][blockType.blockIdentifier];
      }();
      blockType.blockState.directionRelatedBlockStateKey = directionMap[directionMark];
      return blockType;
    } } };exports.utils = utils;

},{"./constructor":2}]},{},[1]);
